#ifndef CHAINLENGTH
	#error You must define CHAINLENGTH
#endif

#if(CHAINLENGTH < 4 || CHAINLENGTH > 30)
	#error CHAINLENGTH must be >= 4 and <= 30.
#endif

// MAXENERGY is (int)(sqrt(CHAINLENGTH)-1)**2  ==  N + 1 - TWOSQRT
#if(CHAINLENGTH <= 4)
	#define TWOSQRT 4
#else
#if(CHAINLENGTH <= 6)
	#define TWOSQRT 5
#else
#if(CHAINLENGTH <= 9)
	#define TWOSQRT 6
#else
#if(CHAINLENGTH <= 12)
	#define TWOSQRT 7
#else
#if(CHAINLENGTH <= 16)
	#define TWOSQRT 8
#else
#if(CHAINLENGTH <= 20)
	#define TWOSQRT 9
#else
#if(CHAINLENGTH <= 25)
	#define TWOSQRT 10
#else
#if(CHAINLENGTH <= 30)
	#define TWOSQRT 11
#else
#if(CHAINLENGTH <= 35)
	#define TWOSQRT 12
#else
	#error You are out of your mind!
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#define MAXENERGY (CHAINLENGTH + 1 - TWOSQRT)

#define MAXNRCONNS (MAXENERGY)

// Define MAXCONNR as the number of possible connection numbers,
// including the terminator 0.
#if(CHAINLENGTH & 1)		// Odd?
	#define MAXCONNR  (((CHAINLENGTH-3)*(CHAINLENGTH-1))/4+1)
#else
	#define MAXCONNR  (((CHAINLENGTH-2)*(CHAINLENGTH-2))/4+1)
#endif

#if(MAXCONNR > 256)
	#error The maximum connection number does not fit in a char
#endif

#if(CHAINLENGTH <= 32)
	typedef unsigned long seq_ulong;
#else
	#error You are a madman
#endif


// The input format of the preparing program for part 2.
struct part2_input
{
	char degen;
	unsigned char conns[MAXNRCONNS];
};

struct part2_output
{
	unsigned int id;		// The number of the structure in the input file, if only
								// non-degenerate structures are counted.
	seq_ulong seq;			// Sequence with unique ground state.
};

struct node_d		// Disk node.
{
	unsigned int number;	// The highest bit is a flag, degen.
	unsigned char conns[MAXNRCONNS];
	char connlen;
	char wilds;
};

