#include "knet.h"

using namespace std;

inline void rule_canal2::evaluatenode(knode_t &k, int i, state_t &s1, state_t &s2)
{
	int ins = k.inputs.size();
	rule_canal2 &r = k.rule;
	if(!ins)
	{
		s2[i] = r._rule[0];
		return;
	}
	for(int j = 0; j < ins; j++)
	{
		if(s1[k.inputs[j]] == r._rule[j << 1])
		{
			s2[i] = r._rule[(j << 1) + 1];
			return;
		}
	}
	s2[i] = r._rule[(ins << 1) - 1] ^ 1;
}

void rule_canal2::evaluate(knet_t &net, state_t &s1, state_t &s2)
{
	const int s = net.size();
	for(int i = 0; i < s; i++)
		evaluatenode(net[i], i, s1, s2);
}

void rule_canal2::randomize(knet_basic<rule_canal2>::type &net,
	bool dummy)
{
	const int s = net.size();
	for(int i = 0; i < s; i++)
	{
		knode_basic<rule_canal2> &k = net[i];
		int ins = k.inputs.size();
		if(!ins)
		{
			vector<char> &r = k.rule._rule;
			r.resize(1);
			r[0] = random_bool(1);
			continue;
		}

		for(int j = ins; j > 1; j--)
		{
			int pos = gsl_rng_uniform_int(rng, j);
			if(pos != j - 1)
				swap(k.inputs[pos], k.inputs[j - 1]);
		}

/*printf("%d <-", i);
for(int j = 0; j < ins; j++)
	printf(" %d", k.inputs[j]);
printf("\n");*/

		vector<char> &r = k.rule._rule;
		r.resize(ins << 1);
		for(int j = 0; j < ins; j++)
		{
			r[(j << 1) + 0] = random_bool(j + 1);
			r[(j << 1) + 1] = random_bool(j + 1);
		}
	}
}

void rule_canal2::fixInput(knode_t &k, int index, int value)
{
	if((int)k.inputs.size() <= index || index < 0)
	{
		cerr << "bad input erase\n";
		exit(1);
	}
	vector<char> &r = k.rule._rule;
	if(k.inputs.size() == 1)
	{
		k.inputs.clear();
		r[0] = value ^ r[0] ^ r[1];
		r.resize(1);
	}
	else if(r[index * 2] == value)
	{
		int outv = r[index * 2 + 1];
		int minindex = index;
		while(minindex > 0 && r[minindex * 2 - 1] == outv)
			minindex--;
		if(minindex == 0)
		{
			k.inputs.clear();
			r[0] = outv;
			r.resize(1);
		}
		else
		{
			k.inputs.resize(minindex);
			r.resize(minindex * 2);
		}
	}
	else if(index == (int)k.inputs.size() - 1)
	{
		int outv = r[index * 2 + 1];
		int minindex = index;
		while(minindex > 0 && r[minindex * 2 - 1] != outv)
			minindex--;
		if(minindex == 0)
		{
			k.inputs.clear();
			r[0] = !outv;
			r.resize(1);
		}
		else
		{
			k.inputs.resize(minindex);
			r.resize(minindex * 2);
		}
	}
	else
	{
		k.inputs.erase(k.inputs.begin() + index);
		r.erase(r.begin() + index * 2, r.begin() + index * 2 + 2);
	}
}
