/**
 * Filename     : compartmentNeighborhood.h
 * Description  : Classes describing compartment neighborhoods
 * Author(s)    : Henrik Jonsson (henrik@thep.lu.se)
 * Created      : September 2005
 * Revision     : $Id: compartmentNeighborhood.h,v 1.7 2006/03/28 08:54:59 henrik Exp $
 */
#ifndef COMPARTMENTNEIGHBORHOOD_H
#define COMPARTMENTNEIGHBORHOOD_H

#include "baseCompartmentNeighborhood.h"
#include "organism.h"

//!Defines neighborhood by looking at distances between spheres
class NeighborhoodDistanceSphere : public BaseCompartmentNeighborhood {
  
 public:
  
  NeighborhoodDistanceSphere(std::vector<double> &paraValue, 
			     std::vector< std::vector<size_t> > 
			     &indValue );
  
  unsigned int create(Organism &O, std::vector< std::vector<double> > &y,
	     double t=0.0 );
  unsigned int update(Organism &O, std::vector< std::vector<double> > &y,
	     double t=0.0 );  
};


#endif


