/**
 * Filename     : degradation.h
 * Description  : Classes describing degradation of molecules
 * Author(s)    : Henrik Jonsson (henrik@thep.lu.se)
 * Created      : October 2003
 * Revision     : $Id: degradation.h,v 1.4 2006/03/18 12:23:08 henrik Exp $
 */
#ifndef DEGRADATION_H
#define DEGRADATION_H

#include "baseReaction.h"

//!DegradationOne assumes a degradation proportional to the concentration
class DegradationOne : public BaseReaction {
  
 public:
  
  DegradationOne(std::vector<double> &paraValue, 
		 std::vector< std::vector<size_t> > &indValue );
  
  void derivs(Compartment &compartment,size_t species,
	      std::vector< std::vector<double> > &y,
	      std::vector< std::vector<double> > &dydt );
};

//!DegradationTwo applies a degradation prop to the concentration of A and B
class DegradationTwo : public BaseReaction {
  
 public:
  
  DegradationTwo(std::vector<double> &paraValue, 
		 std::vector< std::vector<size_t> > &indValue );
  
  void derivs(Compartment &compartment,size_t species,
	      std::vector< std::vector<double> > &y,
	      std::vector< std::vector<double> > &dydt );
};

#endif


